//------------------------------------------
//
//    Grid Actions
//
//------------------------------------------

var myTips = [];

/**
 * Gen report from selected itens
 */

function genReportFromGrid( reportType, objectType) {
	
	var URL = '/opmon/seagull/www/index.php/opreports/action/index/';
	
	// Set reportType
	URL += '?formTo=' + reportType;
	
	// Set manualMode
	var manualMode = new Object();
	manualMode.reportType = '0';
	manualMode.timeCutName = '24x7';
	manualMode.reportPeriod	= 'last24hours';
	manualMode.objectType = objectType;
	manualMode.timeCutId = Ext.get('gridReportPeriod').dom.innerHTML;
	if (reportType == AVAILREPORT)
		manualMode.reportType = AVAILDETAILED;
	manualMode.selectedItens = new Array();
	
	// Get selected items
	var elArray = new Array();
	elArray = Ext.query('input');
	var count = 0;
	for( i = 1; i<(elArray.length-1); i++ ) {
		var el = elArray[i];
		if (el.checked) {
			
			// Host graph
			if (objectType == HOST)
				manualMode.selectedItens.push( el.id );
			
			// Service graph
			if (objectType == SERVICE) {
				var objIds = new Array();
				objIds = el.id.split("_");
				manualMode.selectedItens.push( objIds[0] + "!" + objIds[1] );
			} 
			
			count += 1;
			
		}
	}
	
	if (count) {
		
		var param = Ext.util.JSON.encode(manualMode);
		param = param.replace(/\"/g, "'");
		URL += '&manualMode=' + param;

		var frame = parent.Ext.get('mainFrame');
		frame.dom.src = URL;
		
	} else {
		
		// TODO
		alert("SELECIONE UM OBJETO");
		
	}
	
}

function runExternalCommand( objectType ) {
	
	// Get selected items
	var objects = new Array();
	var elArray = new Array();
	elArray = Ext.query('input');
	var count = 0;
	for( i = 1; i<(elArray.length-1); i++ ) {
		var el = elArray[i];
		if (el.checked) {
			
			// Host graph
			if (objectType == HOST)
				objects.push( el.id );
			
			// Service graph
			if (objectType == SERVICE) {
				var objIds = new Array();
				objIds = el.id.split("_");
				objects.push( objIds[0] + "!" + objIds[1] );
			} 
			count += 1;
		}
	}
	
	if (count) {
		
		var elements = Ext.util.JSON.encode(objects);
		// Create command window
		var win = new Ext.Window({
				applyTo:		'cmdWin',
				id:			'extCmdWin',
				layout:		'fit',	
				width:		250,
				autoHeight:	true,
				y:	100,
				buttonAlign:	'center',
				plain:		false,
				modal:		true,
				closable:	false,
				closeAction: 'hide',
				draggable:	false,
				shadow: false,
				baseCls: 'ext-window',
				bodyBorder: false,
				hideBorders: true,
				border: true,
				resizable: false,
				autoLoad: {
					url: '/opmon/seagull/www/index.php/statusgrid/action/external_command_list/?',
					method: 'POST',
					params: { elements: elements, objectType: objectType },
					text: langArray['Loading'] + '...',
					nocache: true
				}
		});
		win.on('hide',function() {
			Ext.get('cmdWin').dom.innerHTML = "";
		});
		win.show();
		
	} else {
		
		// TODO
		alert("SELECIONE UM OBJETO");
		
	}
	
	
}

function displayItems( btn, pattern ) {
	
	var cssClass = 'invisible';
	var oldClass = 'visible';
	if (btn.src.match('plus')) {
		cssClass = 'visible';
		oldClass = 'invisible';
		btn.src = btn.src.replace('plus','minus');
	} else {
		btn.src = btn.src.replace('minus','plus');
	}
		
	var rows = Ext.query('.opgrid-row');
	var separators = Ext.query('.opgrid-row-separator');
	
	var found = 0;
	for( var i = 0; i<rows.length; i++ ) {
		
		var el = rows[i];
		var sep = separators[i];
		if (el.innerHTML.match("displayItems")) {
			if (el.innerHTML.match("'" + pattern + "'")) {
				found = 1;
				continue;
			} else {
				found = 0;
				continue;
			}
		}
		
		if (found) {
			
			var el = Ext.get(el);
			var sep = Ext.get(sep);
			if (el.hasClass(oldClass)) {
				el.replaceClass(oldClass,cssClass);
				sep.replaceClass(oldClass,cssClass);
			} else {
				el.addClass(cssClass);
				sep.addClass(cssClass);
			}
			
		}
		
	}
	
}

function noWrapFields( field ) {
	
	var css = ".opgrid-field-" + field;
	var fields = Ext.query(css);
	
	for( i=0; i<fields.length; i++ ) {
		
		var obj = Ext.get(fields[i]);
		if (obj.getHeight()>20 && obj.dom.innerHTML.length && !obj.dom.innerHTML.match('tt-truncate')) {
			
			var string = obj.dom.innerHTML;
			var newSize = parseInt((obj.getWidth()-10)/7);
			var size = obj.dom.innerHTML.length;
			
			// Adjust the string size
			var reg = /(<a.*<\/a>)/i;
			var parse = reg.exec( obj.dom.innerHTML );
			if (parse) {
				var tmp = string.replace( parse[1], '' );
				obj.dom.innerHTML = parse[1] + tmp.slice(0,10);
			} else 
				obj.dom.innerHTML = obj.dom.innerHTML.slice(0,newSize-6);

			// Create tooltip
			var curTime = new Date();
			var id = "tt_" + Math.floor(Math.random()*curTime.getTime());
			var el = "<span class='tt-truncate' id='" + id + "' style='cursor:pointer'> (...)</span>";
			obj.dom.innerHTML += el;
			
			new Ext.ToolTip({
				target: id,
				mouseOffset: [ (Ext.isIE) ? document.documentElement.clientWidth-250 : -250, 10],
				autoWidth: true,
				showDelay: 0,
				dismissDelay: 0,
				autoHide: true,
				bodyBorder: false,
				frame: false,
				baseCls: 'object-tooltip',
				html: string
			});
			
		}
	}
	
}

function genRealtimeGraph() {
	
	// Get selected items
	var elArray = new Array();
	elArray = Ext.query('input');
	var count = 0;
	for( i = 1; i<(elArray.length-1); i++ ) {
		var el = elArray[i];
		if (el.checked) {
			
			var objIds = new Array();
			objIds = el.id.split("_");
			var url = '/opmon/seagull/www/index.php/statusgrid/action/realtimegraph';
			url += '/host_id/' + objIds[0];
			url += '/service_id/' + objIds[1];
			var win = window.open(url,'','height=340,width=700,scrollbars=no,menubar=no,resizable=no,toolbar=no,location=no,status=no');
			count += 1;
		}
	}
}

//------------------------------------------
//
//    Host Grid Functions
//
//------------------------------------------

/**
 * Add all features to host grid
 */

function normalizeHostGrid() {

	// Check all button
	var checkbox = Ext.get('check_all');
	checkbox.on( 'click', function() {
		
		var value = 0;
		if (checkbox.dom.checked) {
			value = 1;
		}

		var elArray = new Array();
		elArray = Ext.query('input');
		for( i = 1; i<(elArray.length-1); i++ ) {
			var el = elArray[i];
			el.checked = value;
		}
		
	});
	
	// Add host tooltips
	var divArray = Ext.query('.decorator-link');
	for( i = 0; i<divArray.length; i++ ) {
		
		var objEl = Ext.get(divArray[i]);
		if (objEl.dom.id.match(/^tip_[\d]+_[\d]+$/))
			continue;
		if (objEl.dom.href.match(/hostgroup_name/))
			continue;
		if (objEl.dom.href.match(/servicegroup_name/))
			continue;
		
		// Create a new Tooltip for each host
		myTips.push(new Ext.ToolTip({
			target: objEl,
			trackMouse:true,
			mouseOffset: [0, 10],
			width: 400,
			height: 300,
			showDelay: 1000,
			dismissDelay: 0,
			bodyBorder: false,
			frame: false,
			baseCls: 'object-tooltip',
			autoLoad: {
				url: '/opmon/seagull/www/index.php/statusgrid/action/get_host_tooltip/?',
				method: 'POST',
				params: { host_name: objEl.dom.innerHTML },
				text: langArray["Loading"] + '...',
				nocache: true
			}
		}));

	}
	
	//----------------------------
	//
	// Extra tooltips
	//
	//----------------------------
	
	// Add external links tooltip
	var elArray = Ext.query('.additional-links');
	for(i=0;i<elArray.length;i++) {
		var obj = Ext.get(elArray[i]);
		if (obj.dom.className.match('opacity'))
			continue;
			
		if (objEl.dom.id.match(/[\d]+_[\d]+$/))
			continue;
			
		var reg = /addLink_(\d*)/;
		var match = reg.exec(obj.dom.id);
		if (!match)
			continue;
		
		// Create a new Tooltip for each host
		myTips.push(new Ext.ToolTip({
			target: obj,
			mouseOffset: [-150, 5],
			width: 180,
			height: 300,
			showDelay: 1000,
			dismissDelay: 0,
 			hideDelay: 3500,
			autoHide: true,
			bodyBorder: false,
			frame: false,
			baseCls: 'object-tooltip',
			autoLoad: {
				url: '/opmon/seagull/www/index.php/statusgrid/action/get_host_additional_links/?',
				method: 'POST',
				params: { host_id: match[1] },
				text: langArray["Loading"] + '...',
				nocache: true
			}
		}));
		
	}
	
	// Add additional info tooltip
	var elArray = Ext.query('.additional-info');
	for(i=0;i<elArray.length;i++) {
		var obj = Ext.get(elArray[i]);
		if (obj.dom.className.match('opacity'))
			continue;
			
		if (objEl.dom.id.match(/[\d]+_[\d]+$/))
			continue;
			
		var reg = /addInfo_(\d*)/;
		var match = reg.exec(obj.dom.id);
		if (!match)
			continue;

		// Create a new Tooltip for each host
		myTips.push(new Ext.ToolTip({
			target: obj,
			mouseOffset: [-270, 5],
			trackMouse:true,
			width: 300,
			height: 300,
			showDelay: 1000,
			dismissDelay: 0,
			bodyBorder: false,
			frame: false,
			baseCls: 'object-tooltip',
			autoLoad: {
				url: '/opmon/seagull/www/index.php/statusgrid/action/get_host_additional_info/?',
				method: 'POST',
				params: { host_id: match[1] },
				text: langArray["Loading"] + '...',
				nocache: true
			}
		}));
		
	}
	
	// Add monitoring problem tooltip
	var elArray = Ext.query('.monitoring-problem');
	for(i=0;i<elArray.length;i++) {
		var obj = Ext.get(elArray[i]);
		if (obj.dom.className.match('opacity'))
			continue;
			
		if (objEl.dom.id.match(/[\d]+_[\d]+$/))
			continue;
			
		var reg = /mntProblem_(\d*)/;
		var match = reg.exec(obj.dom.id);
		if (!match)
			continue;

		// Create a new Tooltip for each host
		myTips.push(new Ext.ToolTip({
			target: obj,
			mouseOffset: [-270, 5],
			trackMouse:true,
			width: 300,
			height: 300,
			showDelay: 1000,
			dismissDelay: 0,
			bodyBorder: false,
			frame: false,
			baseCls: 'object-tooltip',
			autoLoad: {
				url: '/opmon/seagull/www/index.php/statusgrid/action/get_host_monitoring_problems/?',
				method: 'POST',
				params: { host_id: match[1] },
				text: langArray["Loading"] + '...',
				nocache: true
			}
		}));
		
	}

	// Adjust fields
	//noWrapFields( 'plugin_output' );
	
}

/**
 * Update grid header 
 */

function updateHostGridHeader() {
	
	setInterval( function() {
	
		var start = Ext.get("hostGrid_startPage").dom.value;
		var limit = Ext.get("hostGrid_elementsPerPage").dom.value;
		Ext.Ajax.request({
			url: '/opmon/seagull/www/index.php/statusgrid/action/get_host_grid_header/?',
			method: 'POST',
			params: { start: start, limit: limit },
			success: function(respObj) {
				Ext.get('hostGridPageHeader').dom.innerHTML = respObj.responseText;
			}
		});
	
	}, 60000);
	
	
}

//------------------------------------------
//
//    Service Grid Functions
//
//------------------------------------------

function displayHostServices( btn, host_id ) {
	
	var cssClass = 'invisible';
	var oldClass = 'visible';
	if (btn.src.match('plus')) {
		cssClass = 'visible';
		oldClass = 'invisible';
		btn.src = btn.src.replace('plus','minus');
	} else {
		btn.src = btn.src.replace('minus','plus');
	}
		
	var rows = Ext.query('.opgrid-row');
	var separators = Ext.query('.opgrid-row-separator');
	
	var found = 0;
	for( var i = 0; i<rows.length; i++ ) {
		
		var el = rows[i];
		var sep = separators[i];
		if (el.dom.innerHTML.match("displayHostServices")) {
			if (el.dom.innerHTML.match(host_id)) {
				found = 1;
				continue;
			} else {
				found = 0;
				continue;
			}
		}
		
		if (found) {
			
			var el = Ext.get(el);
			var sep = Ext.get(sep);
			if (el.hasClass(oldClass)) {
				el.replaceClass(oldClass,cssClass);
				sep.replaceClass(oldClass,cssClass);
			} else {
				el.addClass(cssClass);
				sep.addClass(cssClass);
			}
			
		}
		
	}
	
}

function normalizeServiceGrid() {
	
	normalizeHostGrid();
	normalizeOnlyServiceGrid();
	
}

function normalizeOnlyServiceGrid() {
	
	// Check all button
	var checkbox = Ext.get('check_all');
	checkbox.on( 'click', function() {
		
		var value = 0;
		if (checkbox.dom.checked) {
			value = 1;
		}

		var elArray = new Array();
		elArray = Ext.query('input');
		for( i = 1; i<(elArray.length-1); i++ ) {
			var el = elArray[i];
			el.checked = value;
		}
		
	});
	
	// Add service tooltip
	var divArray = Ext.query('.decorator-link');
	for( i = 0; i<divArray.length; i++ ) {

		var objEl = Ext.get(divArray[i]);
		
		if (objEl.dom.href.match(/servicegroup_name/))
			continue;
		
		var reg = /^tip_(\d*)[_]*(\d*)$/;
		var parse = reg.exec( objEl.dom.id );
		
		if (!parse)
			continue;
		
		var host_id = parse[1];
		var service_id = parse[2] || 0;
	
		// Create a new Tooltip for each service
		myTips.push(new Ext.ToolTip({
			target: objEl,
			trackMouse:true,
			mouseOffset: [0, 10],
			width: 300,
			height: 300,
			showDelay: 1000,
			dismissDelay: 0,
			bodyBorder: false,
			frame: false,
			baseCls: 'object-tooltip',
			autoLoad: {
				url: '/opmon/seagull/www/index.php/statusgrid/action/get_service_tooltip/?',
				method: 'POST',
				params: { host_id: host_id, service_id: service_id },
				text: langArray["Loading"] + '...',
				nocache: true
			}
		}));

	}
	
	//----------------------------
	//
	// Extra tooltips
	//
	//----------------------------
	
	// Add external links tooltip
	var elArray = Ext.query('.additional-links');
	for(i=0;i<elArray.length;i++) {
		var obj = Ext.get(elArray[i]);
		if (obj.dom.className.match('opacity'))
			continue;
			
		var reg = /addLink_(\d*)_(\d*)/;
		var match = reg.exec(obj.dom.id);
		if (!match)
			continue;
		
		// Create a new Tooltip for each host
		myTips.push(new Ext.ToolTip({
			target: obj,
			mouseOffset: [-150, 5],
			width: 180,
			height: 300,
			showDelay: 1000,
			dismissDelay: 0,
 			hideDelay: 3500,
			autoHide: true,
			bodyBorder: false,
			frame: false,
			baseCls: 'object-tooltip',
			autoLoad: {
				url: '/opmon/seagull/www/index.php/statusgrid/action/get_service_additional_links/?',
				method: 'POST',
				params: { host_id: match[1], service_id: match[2] },
				text: langArray["Loading"] + '...',
				nocache: true
			}
		}));
		
	}
	
	// Add additional info tooltip
	var elArray = Ext.query('.additional-info');
	for(i=0;i<elArray.length;i++) {
		var obj = Ext.get(elArray[i]);
		if (obj.dom.className.match('opacity'))
			continue;
			
		var reg = /addInfo_(\d*)_(\d*)/;
		var match = reg.exec(obj.dom.id);
		if (!match)
			continue;

		// Create a new Tooltip for each host
		myTips.push(new Ext.ToolTip({
			target: obj,
			mouseOffset: [-270, 5],
			trackMouse:true,
			width: 300,
			height: 300,
			showDelay: 1000,
			dismissDelay: 0,
			bodyBorder: false,
			frame: false,
			baseCls: 'object-tooltip',
			autoLoad: {
				url: '/opmon/seagull/www/index.php/statusgrid/action/get_service_additional_info/?',
				method: 'POST',
				params: { host_id: match[1], service_id: match[2] },
				text: langArray["Loading"] + '...',
				nocache: true
			}
		}));
		
	}
	
	// Add monitoring problem tooltip
	var elArray = Ext.query('.monitoring-problem');
	for(i=0;i<elArray.length;i++) {
		var obj = Ext.get(elArray[i]);
		if (obj.dom.className.match('opacity'))
			continue;
			
		var reg = /mntProblem_(\d*)_(\d*)/;
		var match = reg.exec(obj.dom.id);
		if (!match)
			continue;

		// Create a new Tooltip for each host
		myTips.push(new Ext.ToolTip({
			target: obj,
			mouseOffset: [-270, 5],
			trackMouse:true,
			width: 300,
			height: 300,
			showDelay: 1000,
			dismissDelay: 0,
			bodyBorder: false,
			frame: false,
			baseCls: 'object-tooltip',
			autoLoad: {
				url: '/opmon/seagull/www/index.php/statusgrid/action/get_service_monitoring_problems/?',
				method: 'POST',
				params: { host_id: match[1], service_id: match[2] },
				text: langArray["Loading"] + '...',
				nocache: true
			}
		}));
		
	}
	
	// Adjust fields
	//noWrapFields( 'plugin_output' );
	
}

/**
 * Update grid header 
 */

function updateServiceGridHeader() {
	
	setInterval( function() {
	
		var start = Ext.get("serviceGrid_startPage").dom.value;
		var limit = Ext.get("serviceGrid_elementsPerPage").dom.value;
		Ext.Ajax.request({
			url: '/opmon/seagull/www/index.php/statusgrid/action/get_service_grid_header/?',
			method: 'POST',
			success: function(respObj) {
				Ext.get('serviceGridPageHeader').dom.innerHTML = respObj.responseText;
			}
		});
	
	}, 60000);
	
	
}

//------------------------------------------
//
//    Hostgroup Grid Functions
//
//------------------------------------------

function normalizeHostgroupGrid() {
	
	normalizeHostGrid();

}

function updateHostgroupGridHeader() {
	
	setInterval( function() {
	
		Ext.Ajax.request({
			url: '/opmon/seagull/www/index.php/statusgrid/action/get_hostgroup_grid_header/?',
			method: 'POST',
			success: function(respObj) {
				Ext.get('hostgroupGridPageHeader').dom.innerHTML = respObj.responseText;
			}
		});
	
	}, 60000);
	
}

//------------------------------------------
//
//    Servicegroup Grid Functions
//
//------------------------------------------

function normalizeServicegroupGrid() {
	
	normalizeHostGrid();
	normalizeServiceGrid();

}

/**
 * Update grid header 
 */

function updateServicegroupGridHeader() {
	
	setInterval( function() {
	
		Ext.Ajax.request({
			url: '/opmon/seagull/www/index.php/statusgrid/action/get_servicegroup_grid_header/?',
			method: 'POST',
			success: function(respObj) {
				Ext.get('servicegroupGridPageHeader').dom.innerHTML = respObj.responseText;
			}
		});
	
	}, 60000);
	
	
}

//------------------------------------------
//
//    Notifications Grid Functions
//
//------------------------------------------

function normalizeNotificationsGrid() {
	
	noWrapFields('output');	

}

/**
 * Update grid header 
 */

function updateNotificationGridHeader() {
	
	setInterval( function() {
	
		Ext.Ajax.request({
			url: '/opmon/seagull/www/index.php/statusgrid/action/get_notification_grid_header/?',
			method: 'POST',
			success: function(respObj) {
				Ext.get('notificationGridPageHeader').dom.innerHTML = respObj.responseText;
			}
		});
	
	}, 60000);
	
	
}

//------------------------------------------
//
//    Event Grid Functions
//
//------------------------------------------

function normalizeEventsGrid() {
	
	noWrapFields('data');	

}

/**
 * Update grid header 
 */

function updateEventGridHeader() {
	
	setInterval( function() {
	
		Ext.Ajax.request({
			url: '/opmon/seagull/www/index.php/statusgrid/action/get_events_grid_header/?',
			method: 'POST',
			success: function(respObj) {
				Ext.get('eventGridPageHeader').dom.innerHTML = respObj.responseText;
			}
		});
	
	}, 60000);
	
	
}

//------------------------------------------
//
//    Comment Grid Functions
//
//------------------------------------------

function normalizeCommentsGrid() {
	
	noWrapFields('comment_data');	

}

/**
 * Update grid header 
 */

function updateCommentGridHeader() {
	
	setInterval( function() {
	
		Ext.Ajax.request({
			url: '/opmon/seagull/www/index.php/statusgrid/action/get_comments_grid_header/?',
			method: 'POST',
			success: function(respObj) {
				Ext.get('commentGridPageHeader').dom.innerHTML = respObj.responseText;
			}
		});
	
	}, 60000);
	
	
}

//------------------------------------------
//
//    Downtimes Grid Functions
//
//------------------------------------------

function normalizeDowntimesGrid() {
	
	noWrapFields('comment_data');	

}

/**
 * Update grid header 
 */

function updateDowntimeGridHeader() {
	
	setInterval( function() {
	
		Ext.Ajax.request({
			url: '/opmon/seagull/www/index.php/statusgrid/action/get_downtimes_grid_header/?',
			method: 'POST',
			success: function(respObj) {
				Ext.get('downtimeGridPageHeader').dom.innerHTML = respObj.responseText;
			}
		});
	
	}, 60000);
	
	
}

//------------------------------------------
//
//    Status Popup Functions
//
//------------------------------------------

function adjustTargetLinks() {
	
	var myArray = new Array();
	myArray = Ext.query('a');
	for( var i = 0; i<myArray.length; i++ ) {
		var obj = myArray[i];
		obj.target = '_blank';
	}
	
}
