var SelectedElements = [];
var CollapsedElements = [];

var StatusgridEvents = {

    setTitle: function() {

        var title = Ext.get('gridTitle');
        if (title) {
            if (parent.setPageTitle)
                parent.setPageTitle(title.dom.value,0);
        }

    },

    displayRows: function(img) {

	var arr = Ext.query("." + img.id);
	Ext.each( arr, function(obj) {

	   var row = Ext.get(obj);
	   if (Ext.isIE) {
	       row.dom.style.display = (img.src.match("minus")) ? "none" : "block";
	   } else {
	       row.dom.style.display = (img.src.match("minus")) ? "none" : "table-row";
	   }

	});

	if (img.src.match("minus")) {
	    img.src = img.src.replace("minus","plus");
	    var found = 0;
	    Ext.each(CollapsedElements, function(str,index) {
		if (str == img.id)
		    found = 1;
	    });
	    if (!found)
		CollapsedElements.push(img.id);
	} else {
	    img.src = img.src.replace("plus","minus");
	    Ext.each(CollapsedElements, function(str,index) {
		if (str == img.id)
		    CollapsedElements.splice(index,1);
	    });
	}

    },

    restoreDisplayRows: function() {

	Ext.each(CollapsedElements, function(id) {
	    var img = Ext.get(id);
	    if (img)
		StatusgridEvents.displayRows(img.dom);
	});

    },

    // ------------------------------
    //
    // Checkbox events
    //
    // ------------------------------

    getGridCheckboxes: function() {
        var boxes = [];
        boxes = Ext.query('input[class=row-checkbox]');
        return boxes;
    },
    
    checkAndUncheck: function(main) {
        var boxes = [];
        boxes = this.getGridCheckboxes();
        Ext.each(boxes, function(cbox) {
           cbox.checked = (main.checked) ? true : false;
           StatusgridEvents.verifyCheckbox(false,cbox);

        });

    },

    verifyCheckbox: function(event,cbox) {
        var index = StatusgridEvents.findCheckboxIndex(cbox.id);
        if (cbox.checked == true) {
            if (index == -1)
                SelectedElements.push(cbox.id);
        } else {
            if (index>-1)
                SelectedElements.splice(index,1);
        }

        //Statusgrid.debug( "Buffer size: " + SelectedElements.length );

    },

    addCheckboxListeners: function() {
        // Restore old state
        for (var i=0; i<SelectedElements.length;i++) {
            var checkbox = Ext.get(SelectedElements[i]);
            if (checkbox) {
                checkbox.dom.checked = true;
                StatusgridEvents.verifyCheckbox(false,checkbox.dom);
            }
        }

        // Add new listeners
        Ext.each( this.getGridCheckboxes(), function(element) {
            var checkbox = Ext.get(element);
            checkbox.on('click',StatusgridEvents.verifyCheckbox);
	    MemoryMgr.push(checkbox);
        });
    },

    findCheckboxIndex: function(id) {
        for (var i=0; i<SelectedElements.length;i++) {
            if (id == SelectedElements[i]) {
                return i;
            }
        }
        return -1;
    },

    // ------------------------------
    //
    // Popup events
    //
    // ------------------------------

    noElementSelected: function() {

	var win = Ext.getCmp('alertWin');
	if (!win) {
	    win = new Ext.Window({
		applyTo: 'alertWin',
		id: 'alertWin',
		contentEl: 'noElementsWin',
		layout: 'fit',
		width: 300,
		autoHeight:	true,
		y: 100,
		buttonAlign: 'center',
		plain: false,
		modal: true,
		closable: false,
		closeAction: 'hide',
		draggable: false,
		shadow: false,
		baseCls: 'ext-window',
		bodyBorder: false,
		hideBorders: true,
		border: true,
		resizable: false
	    });
	}

	win.show();

    },

    // ------------------------------
    //
    // Filter events
    //
    // ------------------------------

    validateBasicSearch: function(form) {

        var obj = form.elements[0];
        var btn = parent.Ext.get("cancelSearch");

        if (obj.value.length) {
	    if (!obj.className.match(" filter-active"));
            	obj.className += " filter-active";

            btn.dom.src = btn.dom.src.replace("ico-cancela-busca-disabled.","ico-cancela-busca.");
            btn.dom.style.cursor = "pointer";
        } else {
	    if (obj.className.match(" filter-active"))
		obj.className = "basic-search-input";

            btn.dom.src = btn.dom.src.replace("ico-cancela-busca.","ico-cancela-busca-disabled.");
            btn.dom.style.cursor = "default";
        }

	StatusgridEvents.hideAdvancedSearch();

    },

    cancelSearch: function() {

        var form = parent.Ext.get('searchForm').dom;
        form.reset();

	StatusgridEvents.hideAdvancedSearch();
        parent.mFrame.StatusgridEvents.validateBasicSearch(form);
        form.submit();

    },

    showAdvancedSearch: function() {

        var obj = false;
        var link = false;
        if (parent) {
            obj = parent.mFrame.Ext.get('gridAdvancedSearch');
            var arr = parent.Ext.query('.basic-search-advanced');
            link = Ext.get(arr[0]);
            delete(arr);
        } else {
            obj = mFrame.Ext.get('gridAdvancedSearch');
            var arr = Ext.query('.basic-search-advanced');
            link = Ext.get(arr[0]);
            delete(arr);
        }

        if (obj.dom.style.display == 'block') {
            link.dom.innerHTML = langArray["Advanced options"];
            obj.dom.style.display = 'none';
        } else {
            link.dom.innerHTML = langArray["Hide options"];
            obj.dom.style.display = 'block'
        }

    },

    hideAdvancedSearch: function() {

        var obj = false;
        var link = false;

        if (parent) {
            obj = parent.mFrame.Ext.get('gridAdvancedSearch');
            var arr = parent.Ext.query('.basic-search-advanced');
            link = Ext.get(arr[0]);
        } else {
            obj = mFrame.Ext.get('gridAdvancedSearch');
            var arr = Ext.query('.basic-search-advanced');
            link = Ext.get(arr[0]);
        }

        link.dom.innerHTML = langArray["Advanced options"];
        obj.dom.style.display = 'none';

    },

    validateAdvancedSearch: function(form) {

        var search = false;
        var btn = false;

        if (parent) {
            var arr = parent.Ext.query('.basic-search-input');
	    search = arr[0];
            delete(arr);

            btn = parent.Ext.get("cancelSearch");
        } else {
            var arr = Ext.query('.basic-search-input');
            search = arr[0];
            delete(arr);

            btn = Ext.get("cancelSearch");
        }

        search.value = "(" + langArray["Filter activated"] + ")";
	if (!search.className.match(" filter-active"))
		search.className += " filter-active";

        btn.dom.src = btn.dom.src.replace("ico-cancela-busca-disabled.","ico-cancela-busca.");
        btn.dom.style.cursor = "pointer";

	StatusgridEvents.hideAdvancedSearch();

    },

    renderComboboxes: function() {

	var form = Ext.get('gridAdvancedSearch');
	if (form) {
	    if (form.dom.style.display != 'none')
		return;
	}

	// Clean previous allocated memory
	Ext.each(FilterMemoryMgr, function(memObj,memIndex) {
	    if (memObj.destroy)
		memObj.destroy();
	    else if (memObj.removeAllListeners)
	        memObj.memObj.removeAllListeners();
	});
	FilterMemoryMgr = [];

        var objs = Ext.query('.combo-autocomplete');
        Ext.each( objs, function(x,index) {
            var obj = Ext.get(x);

            var ds = new Ext.data.Store({
                proxy: new Ext.data.HttpProxy({
                    url: '/opmon/seagull/www/index.php/statusgrid/action/comboContent/filter/' + obj.id,
                    method: 'post'
                }),
                reader: new Ext.data.JsonReader({
                    root: 'data',
                    totalProperty: 'total',
                    id: 'id'
                },[
                    {name: 'id', mapping: 'id'},
                    {name: 'display_name', mapping: 'display_name'}
                ])
            });
	    FilterMemoryMgr.push(ds);

            var content = obj.dom.innerHTML;
	    obj.dom.innerHTML = "";
	    var combo = new Ext.form.ComboBox({
                store: ds,
                displayField: 'display_name',
                loadingText: '',
                renderTo: x,
                width: 200,
                hideTrigger: true,
                name: 'filter[' + obj.id + ']',
                minChars: 1,
                value: content,
                cls: 'advanced-form-element',
		id: 'combo_' + obj.id
            });
	    FilterMemoryMgr.push(combo);

        });

    },

    renderDatetimePicker: function() {

	Date.monthNames = [
	    langArray["Jan"],
	    langArray["Feb"],
	    langArray["Mar"],
	    langArray["Apr"],
	    langArray["May"],
	    langArray["Jun"],
	    langArray["Jul"],
	    langArray["Aug"],
	    langArray["Sep"],
	    langArray["Oct"],
	    langArray["Nov"],
	    langArray["Dec"]
	];

	Date.dayNames = [
	    langArray["Sunday"],
	    langArray["Monday"],
	    langArray["Tuesday"],
	    langArray["Wednesday"],
	    langArray["Thursday"],
	    langArray["Friday"],
	    langArray["Saturday"]
	];

	if(Ext.DatePicker){
	    Ext.apply(Ext.DatePicker.prototype, {
	      todayText         : langArray["Today"],
	      monthNames        : Date.monthNames,
	      dayNames          : Date.dayNames,
	      cancelText	: langArray["Cancel"]
	    });
	}

	var form = Ext.get('gridAdvancedSearch');
	if (form) {
	    if (form.dom.style.display != 'none')
		return;
	}

        var objs = Ext.query('.date-picker');
        Ext.each( objs, function(x,index) {

            var obj = Ext.get(x);
            var content = obj.dom.innerHTML;
	    obj.dom.innerHTML = "";
	    var field = new Ext.form.DateField({
		editable: false,
		format: 'Y-m-d',
                renderTo: x,
                width: 100,
                name: 'filter[' + obj.id + ']',
                value: content,
                cls: 'advanced-form-element',
		id: 'combo_' + obj.id
            });
	    FilterMemoryMgr.push(field);
	    
        });

    },

    // ------------------------------
    //
    // Toolbar events
    //
    // ------------------------------

    adjustGridLayout: function() {

	var header = Ext.get('gridHeaderBox');
	if (!header)
	    return;
	var tbar = Ext.get('gridToolbar');
	if (!tbar)
	    return;

	tbar.setWidth( header.getWidth() );

	var body = Ext.getBody();
	if (!body)
	    return;
	var tableBody = Ext.get('gridTableBody');
	if (!tableBody)
	    return;
	var newSize = body.getHeight()-130;

	if (tableBody.getHeight()>=newSize)
	    tableBody.setHeight(newSize);
	else {
	    if (tableBody.dom.style.removeAttribute)
		tableBody.dom.style.removeAttribute("height");
	    else
		tableBody.dom.style.removeProperty("height");
	}

    },

    genReportFromGrid: function(reportType, objectType) {

        var URL = '/opmon/seagull/www/index.php/opreports/action/index/';

        // Set reportType
        URL += '?formTo=' + reportType;

        // Set manualMode
        var manualMode = new Object();
        manualMode.reportType = '0';
        manualMode.timeCutName = '24x7';
        manualMode.reportPeriod	= 'last24hours';
        manualMode.objectType = objectType;
        manualMode.timeCutId = Ext.get('gridReportPeriod').dom.value;
        if (reportType == AVAILREPORT)
            manualMode.reportType = AVAILDETAILED;
        manualMode.selectedItens = SelectedElements;

        if (manualMode.selectedItens.length) {

            var param = Ext.util.JSON.encode(manualMode);
            param = param.replace(/\"/g, "'");
            URL += '&manualMode=' + param;

            var frame = parent.Ext.get('mainFrame');
            frame.dom.src = URL;

        } else {
            StatusgridEvents.noElementSelected();
        }

    },

    runExternalCommand: function(objectType) {

	// Get selected items
	var objects = [];
        objects = SelectedElements;

	if (objects.length) {

	    var elements = Ext.util.JSON.encode(objects);
	    // Create command window
	    var win = new Ext.Window({
		applyTo:		'cmdWin',
		id:			'extCmdWin',
		layout:		'fit',
		width:		250,
		autoHeight:	true,
		y:	100,
		buttonAlign:	'center',
		plain:		false,
		modal:		true,
		closable:	false,
		closeAction: 'hide',
		draggable:	false,
		shadow: false,
		bodyCssClass: 'ext-window',
		bodyBorder: false,
		hideBorders: true,
		border: true,
		resizable: false,
		autoLoad: {
		    url: '/opmon/seagull/www/index.php/statusgrid/action/external_command_list/?',
		    method: 'POST',
		    params: {elements: elements, objectType: objectType},
		    text: langArray['Loading'] + '...',
		    nocache: true
		}
	    });
	    win.on('hide',function() {
		    Ext.get('cmdWin').dom.innerHTML = "";
	    });
	    win.show();

        } else {
            StatusgridEvents.noElementSelected();
        }

    },

    genRealtimeGraph: function() {

	// Get selected items
	var objects = [];
        objects = SelectedElements;

	if (objects.length) {
	    Ext.each(objects,function(obj,index) {

		if (obj.indexOf("!") != -1) {
			var objIds = [];
			objIds = obj.split("!");
			var url = '/opmon/seagull/www/index.php/statusgrid/action/realtimegraph';
			url += '/host_id/' + objIds[0];
			url += '/service_id/' + objIds[1];
			var win = window.open(url,'','height=340,width=800,scrollbars=no,menubar=no,resizable=yes,toolbar=no,location=no,status=no');
		}

	    });
	} else {
	    StatusgridEvents.noElementSelected();
	}

    },

    addFavoriteLink: function() {
        if (parent)
            parent.addFavoriteLink();
    },

    addShortcutLink: function() {
        if (parent)
            parent.addShortcutLink();
    }

}
